import vl from 'vega-lite-api';
const hover = vl.selectSingle()
    .encodings('x')  // limit selection to x-axis value
    .on('mouseover') // select on mouseover events
    .nearest(true)   // select data point nearest the cursor
    .empty('none')
    .clear("mouseout");


const area = vl.markArea()
    .encode(
      vl
      .y()
      .fieldQ('CARS')
      .title('CARS Registered'),

    vl
      .x()
      .fieldT('FISCAL_YEAR')
      .scale({ nice: true })
      .title(' FISCAL_YEAR '));

const circle=
      vl.markCircle()
  .encode(
    vl
      .y()
      .fieldQ('CARS'),
    
    vl
      .x()
      .fieldT('FISCAL_YEAR')
      .scale({ nice: true }));
      

const base = area.transform(vl.filter(hover));
const label = {align: 'left', dx: 5, dy: -5};
const white = {stroke: 'red', strokeWidth: 15};

export const viz =
  vl.layer(circle,
    area,
    area.markCircle()
        .select(hover) // use as anchor points for selection
        .encode(vl.opacity().if(hover, vl.value(1)).value(0)),
    vl.markRule({color: 'red'})
        .transform(vl.filter(hover))
        .encode(vl.x().fieldT('FISCAL_YEAR')),
    base.markText(label, white).encode(vl.text().fieldQ('CARS')),
    base.markText(label).encode(vl.text().fieldQ('CARS')));
console.log('test')